## xppsm-2.2.0-ubuntu17.10.tar

=== Makefile ===
# Copyright (c) 2017, Intel Corporation.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms and conditions of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
#
# This program is distributed in the hope it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.

KERNEL_SRC ?= /lib/modules/$(shell uname -r)/build

RELEASE_FILE := include/config/kernel.release

ifneq ($(wildcard $(O)/$(RELEASE_FILE)),)
KERNEL_BUILD := $(O)
else ifneq ($(wildcard $(KERNEL_SRC)/$(RELEASE_FILE)),)
KERNEL_BUILD := $(KERNEL_SRC)
else
$(error Unable to detect kernel build tree. Please specify it as KERNEL_SRC param)
endif

KERNEL_RELEASE := $(shell cat $(KERNEL_BUILD)/include/config/kernel.release)
KERNEL_MODULES := /lib/modules/$(KERNEL_RELEASE)/extra/zonesort

BUILD_MODULES_SIGN := false

$(info == zonesort build configuration:)
$(info MODULE_VERSION:          $(MODULE_VERSION))
$(info KERNEL_BUILD:            $(KERNEL_BUILD))
$(info KERNEL_RELEASE:          $(KERNEL_RELEASE))
$(info KERNEL_MODULES:          $(KERNEL_MODULES))
$(info BUILD_MODULES_SIGN:      $(BUILD_MODULES_SIGN))

# define kernel config for the MIC
KCONFIG += CONFIG_INTEL_ZONESORT=m
KCONFIG += CONFIG_INTEL_ZONESORT_VERSION=$(MODULE_VERSION)

INSTALL = install
INSTALL_d = $(INSTALL) -d
INSTALL_x = $(INSTALL)
INSTALL_f = $(INSTALL) -m644

.PHONY: all install modules clean
.PHONY: modules_install
.PHONY: modules_sign

all: modules

install: modules_install

# TODO: implement module signing
modules_sign:
	xpps-modsign.sh --modules-dir $(CURDIR)

ifeq ($(BUILD_MODULES_SIGN),true)
modules_install: modules_sign
endif

modules:
	$(MAKE) -j $(PARALLEL) -C $(KERNEL_BUILD) M=$(CURDIR) $(KCONFIG) $@

clean:
	$(MAKE) -j $(PARALLEL) -C $(KERNEL_BUILD) M=$(CURDIR) $(KCONFIG) clean

modules_install: modules
	$(INSTALL_d) $(DESTDIR)$(KERNEL_MODULES)
	$(INSTALL_f) zonesort/zonesort.ko $(DESTDIR)$(KERNEL_MODULES)

=== data/Makefile ===
INSTALL ?= install
VERSION ?= 0.0.0
prefix ?= /usr
datarootdir ?= $(prefix)/share
datadir ?= $(datarootdir)

all: knlsb

knlsb:

knllb:

install: install-knlsb

install-knlsb:
	$(INSTALL) -d $(DESTDIR)$(datadir)/micperf/data
	$(INSTALL) -m 644 knlsb/README.txt $(DESTDIR)$(datadir)/micperf/data
	- $(INSTALL) -m 644 knlsb/*.pkl $(DESTDIR)$(datadir)/micperf/data

install-knllb:
	$(INSTALL) -d $(DESTDIR)$(datadir)/micperf/data
	- $(INSTALL) -m 644 knllb/README.txt $(DESTDIR)$(datadir)/micperf/data
	- $(INSTALL) -m 644 knllb/*.pkl $(DESTDIR)$(datadir)/micperf/data

.PHONY: all knc knlsb knllb install install-knc install-knlsb install-knllb

=== doc/Makefile ===
INSTALL ?= install
VERSION ?= 0.0.0
prefix ?= /usr
datarootdir ?= $(prefix)/share
datadir ?= $(datarootdir)
docdir ?= $(datarootdir)/doc/micperf

all:
	-

install: micperf_users_guide.pdf
	$(INSTALL) -D -m 644 micperf_users_guide.pdf ${DESTDIR}$(docdir)/user_guide.pdf

clean:
	-

.PHONY:  all install install-server clean

=== gemm/Makefile ===
##******************************************************************************
##  Copyright(C) 2011-2012 Intel Corporation. All Rights Reserved.
##
##  The source code, information  and  material ("Material") contained herein is
##  owned  by Intel Corporation or its suppliers or licensors, and title to such
##  Material remains  with Intel Corporation  or its suppliers or licensors. The
##  Material  contains proprietary information  of  Intel or  its  suppliers and
##  licensors. The  Material is protected by worldwide copyright laws and treaty
##  provisions. No  part  of  the  Material  may  be  used,  copied, reproduced,
##  modified, published, uploaded, posted, transmitted, distributed or disclosed
##  in any way  without Intel's  prior  express written  permission. No  license
##  under  any patent, copyright  or  other intellectual property rights  in the
##  Material  is  granted  to  or  conferred  upon  you,  either  expressly,  by
##  implication, inducement,  estoppel or  otherwise.  Any  license  under  such
##  intellectual  property  rights must  be express  and  approved  by  Intel in
##  writing.
##
##  *Third Party trademarks are the property of their respective owners.
##
##  Unless otherwise  agreed  by Intel  in writing, you may not remove  or alter
##  this  notice or  any other notice embedded  in Materials by Intel or Intel's
##  suppliers or licensors in any way.
##
##******************************************************************************
##  Content:
##      Makefile for SGEMM, DGEMM, CGEMM, ZGEMM benchmarks
##******************************************************************************

ICC		?= icc
TARGET_ICC	?= $(ICC)
INSTALL		?= install
VERSION		?= 0.0.0
prefix		?= /usr
exec_prefix	?= $(prefix)
libexecdir	?= $(exec_prefix)/libexec
datarootdir	?= $(prefix)/share
docdir		?= $(datarootdir)/doc
srcinstalldir	?= $(prefix)/src/micperf
card_libs ?= /opt/mpss/x200/minsdk/lib

all: knc

COMPOSER_VER = $(if $(findstring 2018, $(MKLROOT)),2018,2017)
ifeq ($(COMPOSER_VER),2018)
addprec = $(foreach x, s d i, $(x)$(strip $(1)))
# TODO: temporary path until MKL 2018 GOLD will not be released,
# as soon as KNM build will be performed by MKL 2018 GOLD
# this line can be removed
MKLROOT = /opt/sid-toolchains/libs/mkl_2018.0.031/mkl
else
addprec = $(foreach x, s d, $(x)$(strip $(1)))
endif

CPU_TARGETS	= $(call addprec, gemm_cpu.x)
MIC_TARGETS	= $(call addprec, gemm_mic.x)
OFL_TARGETS	= $(call addprec, gemm_ofl.x)
MCDRAM_CPU_TARGETS = $(call addprec, gemm_mcdram_cpu.x)
KNL_SNC_TARGETS = $(call addprec, gemm_mpi_snc_cpu.x)

TARGETS		= $(MIC_TARGETS) $(CPU_TARGETS) $(OFL_TARGETS) \
$(MCDRAM_CPU_TARGETS) $(KNL_SNC_TARGETS)

SOURCE          = bench.c bench.h main.c Makefile README.txt redist.txt utils.c utils.h cross_timer.h

# BASIC COMPILATION SETUP
MKL_CFLAGS	= -I$(MKLROOT)/include -qopenmp

# SETTING DYNAMIC=yes at make time forces dynamic linking with MKL
ifneq (yes,$(DYNAMIC))
WLSTATIC	= -Wl,-Bstatic
WLDYNAMIC	= -Wl,-Bdynamic
STATIC		= -Bstatic
DYNAMIC		= -Bdynamic
endif
MKL_LIBS	= $(WLSTATIC) -lmkl_intel_lp64 -Wl,--start-group \
                  -lmkl_intel_thread -lmkl_core $(WLDYNAMIC) -Wl,--end-group
MKL_LIBS_LINKER	= $(STATIC) -lmkl_intel_lp64 --start-group \
                  -lmkl_intel_thread -lmkl_core $(DYNAMIC) --end-group

K1OM_BIN_POSTFIX = /mic

MIC_CFLAGS	= $(MKL_CFLAGS) -qno-offload

CPU_CFLAGS	= $(MKL_CFLAGS) -qno-offload
CPU_LIBS	= -L$(MKLROOT)/lib/intel64 $(MKL_LIBS)

knc: OFL_CFLAGS	= $(MKL_CFLAGS)
knc: OFL_LIBS	= $(CPU_LIBS) -offload-option,mic,ld,"-L$(MKLROOT)/lib/mic $(MKL_LIBS_LINKER) --no-undefined"
knc: MIC_LIBS	= -L$(MKLROOT)/lib/mic $(MKL_LIBS)

knllb: OFL_CFLAGS = $(MKL_CFLAGS) -qoffload-arch=mic-avx512 -qoffload-option,mic,compiler,"-L$(card_libs)"
knllb: OFL_LIBS = $(CPU_LIBS) -qoffload-option,mic,ld,"-L$(MKLROOT)/lib/intel64 $(MKL_LIBS_LINKER) -L$(card_libs) --no-undefined" -qoffload-option,mic,link,"-rpath-link=$(card_libs)"
knllb: MIC_LIBS	= -L$(MKLROOT)/lib/intel64 $(MKL_LIBS)

ALL_CFLAGS	= -O2 -Wall -Werror -g -std=c99 -D_FORTIFY_SOURCE=2 -fstack-protector
EXTRA_LDFLAGS = -Wl,-z,relro,-z,now

# PRECISION OPTIONS SELECTION
s%.x	: PREC	= -DSINGLE_PREC
d%.x	: PREC	= -DDOUBLE_PREC
c%.x	: PREC	= -DCOMPLEX
z%.x	: PREC	= -DCOMPLEX16
i%.x    : PREC  = -DINTEGER

# ------- MKL ----------
$(MIC_TARGETS)	: CC		= $(TARGET_ICC)
$(MIC_TARGETS)	: EXTRA_CFLAGS	= $(MIC_CFLAGS)
$(MIC_TARGETS)	: LIBS		= $(MIC_LIBS)
$(CPU_TARGETS)	: CC		= $(ICC)
$(CPU_TARGETS)	: EXTRA_CFLAGS	= $(CPU_CFLAGS)
$(CPU_TARGETS)	: LIBS		= $(CPU_LIBS)
$(OFL_TARGETS)	: CC		= $(ICC)
$(OFL_TARGETS)	: EXTRA_CFLAGS	= $(OFL_CFLAGS)
$(OFL_TARGETS)	: LIBS		= $(OFL_LIBS)
$(MCDRAM_CPU_TARGETS): CC        = $(ICC)
$(MCDRAM_CPU_TARGETS): EXTRA_CFLAGS  = $(CPU_CFLAGS) -DMCDRAM_KNLSB
$(MCDRAM_CPU_TARGETS): LIBS      = $(CPU_LIBS) -lmemkind
$(KNL_SNC_TARGETS): CC		= mpiicc
$(KNL_SNC_TARGETS): EXTRA_CFLAGS  = $(CPU_CFLAGS) -DKNL_SNC_MODE
$(KNL_SNC_TARGETS): LIBS      = $(CPU_LIBS) -lnuma

# Optimize KNL binaries to use AVX512 and KNC card binaries for the k1om architecture
knc: MIC_CFLAGS += -mmic
knlsb: CPU_CFLAGS += -xMIC-AVX512
knllb: MIC_CFLAGS += -xMIC-AVX512

knc: mkl-x86_64 mkl-k1om

knlsb: $(CPU_TARGETS) $(MCDRAM_CPU_TARGETS) $(KNL_SNC_TARGETS)

knllb: mkl-x86_64 mkl-k1om

install: install-knc

install-knc: install-x86_64 install-k1om install-license

install-knlsb: $(CPU_TARGETS) $(MCDRAM_CPU_TARGETS) $(KNL_SNC_TARGETS)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) -d $(DESTDIR)$(docdir)

install-knllb: install-x86_64 install-x86_64-avx512 install-license

mkl-x86_64: $(OFL_TARGETS) $(CPU_TARGETS)

mkl-k1om: $(MIC_TARGETS)

install-x86_64: $(OFL_TARGETS) $(CPU_TARGETS)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/x86_64

install-k1om: $(MIC_TARGETS)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/k1om
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/k1om

install-x86_64-avx512: $(MIC_TARGETS)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512

install-license:
	$(INSTALL) -d $(DESTDIR)$(docdir)

clean:
	-rm -rf $(TARGETS)

$(TARGETS): main.c bench.c bench.h utils.c utils.h cross_timer.h

%.x:
	$(CC) $(ALL_CFLAGS) $(CPPFLAGS) $(EXTRA_CFLAGS) $(CFLAGS) $(PREC) $(LDFLAGS) $(EXTRA_LDFLAGS) $(filter %.c, $^) $(LIBS) -o $@

.PHONY: all knc knlsb knllb mkl-x86_64 mkl-k1om mkl-ofl mkl-cpu mkl-mic clean install install-knc install-knlsb install-knllb install-x86_64 install-k1om

=== micp/Makefile ===
INSTALL ?= install
VERSION ?= 0.0.0
prefix ?= /usr
bindir ?= $(prefix)/bin
exec_prefix ?= $(prefix)
libexecdir ?= $(exec_prefix)/libexec
datarootdir ?= $(prefix)/share
datadir ?= $(datarootdir)
docdir ?= $(datarootdir)/doc/micperf
srcinstalldir ?= $(datadir)/micperf

all: knc

knc: knc_preprocess
	./setup.py sdist --formats=gztar -u root -g root

knlsb: knlsb_preprocess
	# Next command (setup.py) does not have any effect, since install-knlsb does
	# not use package genereted by it. It is here just for unit test purpose, to
	# make sure the command work properly.
	./setup.py sdist --formats=gztar -u root -g root

knllb: knllb_preprocess
	echo "global-exclude hpcg.py" >> MANIFEST.in
	echo "global-exclude libxsmm_conv.py" >> MANIFEST.in
	echo "global-exclude mkl_conv.py" >> MANIFEST.in
	echo "global-exclude fio.py" >> MANIFEST.in
ifneq ($(COMPOSER_VER),2018)
	echo "global-exclude igemm.py" >> MANIFEST.in
endif
	./setup.py sdist --formats=gztar -u root -g root

clean:
	rm -rf build dist MANIFEST micp/*.pyc micp/kernels/*.pyc
	if [ -e micp/version.py.orig ]; then mv micp/version.py.orig micp/version.py; fi
	if [ -e README.txt.orig ]; then mv README.txt.orig README.txt; fi
	if [ -e INSTALL.txt.orig ]; then mv INSTALL.txt.orig INSTALL.txt; fi
	if [ -e micperf_faqs.txt.orig ]; then mv micperf_faqs.txt.orig micperf_faqs.txt; fi

knc_preprocess:
	if [ ! -e micp/version.py.orig ]; then mv micp/version.py micp/version.py.orig; fi
	if [ ! -e INSTALL.txt.orig ]; then cp INSTALL.txt INSTALL.txt.orig; fi
	if [ ! -e micperf_faqs.txt.orig ]; then cp micperf_faqs.txt micperf_faqs.txt.orig; fi
	python ../preprocess_micp.py micp knc $(VERSION) $(datadir) $(libexecdir)

knlsb_preprocess:
	if [ ! -e micp/version.py.orig ]; then mv micp/version.py micp/version.py.orig; fi
	if [ ! -e INSTALL.txt.orig ]; then cp INSTALL.txt INSTALL.txt.orig; fi
	if [ ! -e micperf_faqs.txt.orig ]; then cp micperf_faqs.txt micperf_faqs.txt.orig; fi
	python ../preprocess_micp.py micp knlsb $(VERSION) $(datadir) $(libexecdir)

knllb_preprocess:
	if [ ! -e micp/version.py.orig ]; then mv micp/version.py micp/version.py.orig; fi
	if [ ! -e INSTALL.txt.orig ]; then cp INSTALL.txt INSTALL.txt.orig; fi
	if [ ! -e micperf_faqs.txt.orig ]; then cp micperf_faqs.txt micperf_faqs.txt.orig; fi
	python ../preprocess_micp.py micp knllb $(VERSION) $(datadir) $(libexecdir)

install: install-knc

install-knc:
	$(INSTALL) -d $(DESTDIR)$(docdir)
	$(INSTALL) -m 644 README.txt CHANGES.txt INSTALL.txt LICENSE.txt micperf_faqs.txt $(DESTDIR)$(docdir)
	$(INSTALL) -d $(DESTDIR)$(srcinstalldir)
	tar xvf dist/micp-$(VERSION).tar.gz -C $(DESTDIR)$(srcinstalldir)
	ln -sf micp-$(VERSION) $(DESTDIR)$(srcinstalldir)/micp
	$(INSTALL) -d $(DESTDIR)$(bindir)
	ln -sf $(srcinstalldir)/micp-$(VERSION)/micpcsv $(DESTDIR)$(bindir)/micpcsv
	ln -sf $(srcinstalldir)/micp-$(VERSION)/micpinfo $(DESTDIR)$(bindir)/micpinfo
	ln -sf $(srcinstalldir)/micp-$(VERSION)/micpplot $(DESTDIR)$(bindir)/micpplot
	ln -sf $(srcinstalldir)/micp-$(VERSION)/micpprint $(DESTDIR)$(bindir)/micpprint
	ln -sf $(srcinstalldir)/micp-$(VERSION)/micprun $(DESTDIR)$(bindir)/micprun

install-knlsb:
	$(INSTALL) -d $(DESTDIR)$(docdir)
	$(INSTALL) -m 644 EULA README.txt INSTALL.txt LICENSE.txt micperf_faqs.txt $(DESTDIR)$(docdir)

	$(INSTALL) -d $(DESTDIR)$(srcinstalldir)
	$(INSTALL) -d $(DESTDIR)$(srcinstalldir)/micp
	$(INSTALL) -m 755 micpcsv $(DESTDIR)$(srcinstalldir)/micp/micpcsv
	$(INSTALL) -m 755 micpinfo $(DESTDIR)$(srcinstalldir)/micp/micpinfo
	$(INSTALL) -m 755 micpplot $(DESTDIR)$(srcinstalldir)/micp/micpplot
	$(INSTALL) -m 755 micpprint $(DESTDIR)$(srcinstalldir)/micp/micpprint
	$(INSTALL) -m 755 micprun $(DESTDIR)$(srcinstalldir)/micp/micprun
	$(INSTALL) -m 755 setup.py $(DESTDIR)$(srcinstalldir)/micp/setup.py
	$(INSTALL) -m 755 virsh-kvm-xeon-phi $(DESTDIR)$(srcinstalldir)/micp/virsh-kvm-xeon-phi

	$(INSTALL) -d $(DESTDIR)$(srcinstalldir)/micp/micp
	$(INSTALL) -m 644 micp/__init__.py $(DESTDIR)$(srcinstalldir)/micp/micp/__init__.py
	$(INSTALL) -m 644 micp/common.py $(DESTDIR)$(srcinstalldir)/micp/micp/common.py
	$(INSTALL) -m 644 micp/connect.py $(DESTDIR)$(srcinstalldir)/micp/micp/connect.py
	$(INSTALL) -m 644 micp/info.py $(DESTDIR)$(srcinstalldir)/micp/micp/info.py
	$(INSTALL) -m 644 micp/kernel.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernel.py
	$(INSTALL) -m 644 micp/offload.py $(DESTDIR)$(srcinstalldir)/micp/micp/offload.py
	$(INSTALL) -m 644 micp/params.py $(DESTDIR)$(srcinstalldir)/micp/micp/params.py
	$(INSTALL) -m 644 micp/run.py $(DESTDIR)$(srcinstalldir)/micp/micp/run.py
	$(INSTALL) -m 644 micp/stats.py $(DESTDIR)$(srcinstalldir)/micp/micp/stats.py
	$(INSTALL) -m 644 micp/version.py $(DESTDIR)$(srcinstalldir)/micp/micp/version.py

	$(INSTALL) -d $(DESTDIR)$(srcinstalldir)/micp/micp/kernels
	$(INSTALL) -m 644 micp/kernels/__init__.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/__init__.py
	$(INSTALL) -m 644 micp/kernels/_xgemm.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/_xgemm.py
	$(INSTALL) -m 644 micp/kernels/dgemm.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/dgemm.py
	$(INSTALL) -m 644 micp/kernels/fio.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/fio.py
	$(INSTALL) -m 644 micp/kernels/hpcg.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/hpcg.py
	$(INSTALL) -m 644 micp/kernels/hplinpack.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/hplinpack.py
ifeq ($(COMPOSER_VER),2018)
	$(INSTALL) -m 644 micp/kernels/igemm.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/igemm.py
endif
	$(INSTALL) -m 644 micp/kernels/libxsmm_conv.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/libxsmm_conv.py
	$(INSTALL) -m 644 micp/kernels/linpack.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/linpack.py
	$(INSTALL) -m 644 micp/kernels/mkl_conv.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/mkl_conv.py
	$(INSTALL) -m 644 micp/kernels/sgemm.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/sgemm.py
	$(INSTALL) -m 644 micp/kernels/stream.py $(DESTDIR)$(srcinstalldir)/micp/micp/kernels/stream.py

	$(INSTALL) -d $(DESTDIR)$(bindir)
	ln -sf $(srcinstalldir)/micp/micpcsv $(DESTDIR)$(bindir)/micpcsv
	ln -sf $(srcinstalldir)/micp/micpinfo $(DESTDIR)$(bindir)/micpinfo
	ln -sf $(srcinstalldir)/micp/micpplot $(DESTDIR)$(bindir)/micpplot
	ln -sf $(srcinstalldir)/micp/micpprint $(DESTDIR)$(bindir)/micpprint
	ln -sf $(srcinstalldir)/micp/micprun $(DESTDIR)$(bindir)/micprun

install-knllb:
	$(INSTALL) -d $(DESTDIR)$(docdir)
	$(INSTALL) -m 644 EULA README.txt CHANGES.txt INSTALL.txt LICENSE.txt micperf_faqs.txt $(DESTDIR)$(docdir)
	$(INSTALL) -d $(DESTDIR)$(srcinstalldir)
	tar xf dist/micp-$(VERSION).tar.gz -C $(DESTDIR)$(srcinstalldir)
	ln -sf micp-$(VERSION) $(DESTDIR)$(srcinstalldir)/micp
	$(INSTALL) -d $(DESTDIR)$(bindir)
	ln -sf $(srcinstalldir)/micp-$(VERSION)/micpcsv $(DESTDIR)$(bindir)/micpcsv
	ln -sf $(srcinstalldir)/micp-$(VERSION)/micpinfo $(DESTDIR)$(bindir)/micpinfo
	ln -sf $(srcinstalldir)/micp-$(VERSION)/micpplot $(DESTDIR)$(bindir)/micpplot
	ln -sf $(srcinstalldir)/micp-$(VERSION)/micpprint $(DESTDIR)$(bindir)/micpprint
	ln -sf $(srcinstalldir)/micp-$(VERSION)/micprun $(DESTDIR)$(bindir)/micprun

.PHONY: all knc knlsb knllb clean install install-knc install-knlsb install-knllb knc_preprocess knllb_preprocess knlsb_preprocess

=== shoc/Makefile ===
##******************************************************************************
##  Copyright(C) 2011-2012 Intel Corporation. All Rights Reserved.
##
##  The source code, information  and  material ("Material") contained herein is
##  owned  by Intel Corporation or its suppliers or licensors, and title to such
##  Material remains  with Intel Corporation  or its suppliers or licensors. The
##  Material  contains proprietary information  of  Intel or  its  suppliers and
##  licensors. The  Material is protected by worldwide copyright laws and treaty
##  provisions. No  part  of  the  Material  may  be  used,  copied, reproduced,
##  modified, published, uploaded, posted, transmitted, distributed or disclosed
##  in any way  without Intel's  prior  express written  permission. No  license
##  under  any patent, copyright  or  other intellectual property rights  in the
##  Material  is  granted  to  or  conferred  upon  you,  either  expressly,  by
##  implication, inducement,  estoppel or  otherwise.  Any  license  under  such
##  intellectual  property  rights must  be express  and  approved  by  Intel in
##  writing.
##
##  *Third Party trademarks are the property of their respective owners.
##
##  Unless otherwise  agreed  by Intel  in writing, you may not remove  or alter
##  this  notice or  any other notice embedded  in Materials by Intel or Intel's
##  suppliers or licensors in any way.
##
##******************************************************************************
##  Content:
##      Makefile for SHOC
##******************************************************************************

ICC ?= icc
ICPC ?= icpc
TARGET_ICC ?= $(ICC)
TARGET_ICPC ?= $(ICPC)
INSTALL ?= install
VERSION ?= 0.0.0
prefix ?= /usr
exec_prefix ?= $(prefix)
libexecdir ?= $(exec_prefix)/libexec
datarootdir ?= $(prefix)/share
docdir ?= $(datarootdir)/doc/micperf
srcinstalldir ?= $(prefix)/src/micperf
card_libs ?= /opt/mpss/x200/minsdk/lib

TARGETS_x86_64 = BusSpeedDownload_pragma BusSpeedReadback_pragma BusSpeedDownload_scif BusSpeedReadback_scif
TARGETS_k1om = BusSpeed_mic
TARGETS = $(TARGETS_x86_64) $(TARGETS_k1om)

knc: TARGET_ICC += -mmic
knc: TARGET_ICPC += -mmic
knllb: TARGET_ICC += -xMIC-AVX512
knllb: TARGET_ICPC += -xMIC-AVX512

SOURCE = BusSpeedDownload_pragma.cpp BusSpeedDownload_scif.cpp BusSpeedReadback_pragma.cpp \
         BusSpeedReadback_scif.cpp main.cpp main_mic.c Option.cpp Option.h OptionParser.cpp \
         OptionParser.h ResultDatabase.cpp ResultDatabase.h \
         cross_timer.h Utility.h Makefile

all: knc
knc: $(TARGETS_x86_64) $(TARGETS_k1om)
knllb: $(TARGETS_x86_64) $(TARGETS_k1om)

install: install-knc

install-knc: install-x86_64 install-k1om install-license

install-knllb: install-x86_64 install-x86_64-avx512 install-license

$(TARGETS_x86_64) : CC = $(ICC)
$(TARGETS_x86_64) : CXX = $(ICPC)
$(TARGETS_k1om) : CC = $(TARGET_ICC)
$(TARGETS_k1om) : CXX = $(TARGET_ICPC)

COMMON_SRC = main.cpp Option.cpp OptionParser.cpp ResultDatabase.cpp

CFLAGS_k1om = $(shell echo $(CFLAGS) | sed -e 's/x86_64-linux-nativepkg/knightscorner/g')
LDFLAGS_k1om = $(shell echo $(LDFLAGS) | sed -e 's/x86_64-linux-nativepkg/knightscorner/g')

CXXFLAGS_pragma = -Wall -parallel -g -O3 -qopenmp -intel-extensions -I$(MKLROOT)/include -lrt
CFLAGS_scif = -Wall -g -O3 -DSCIF_SHOC -lrt -lscif
CXXFLAGS_scif = $(CFLAGS_scif)
knllb: KNLLB_FLAGS_pragma = -qoffload-arch=mic-avx512 -qoffload-option,mic,compiler,"-L$(card_libs)" -qoffload-option,mic,link,"-rpath-link=$(card_libs)"

BusSpeed%_pragma: BusSpeed%_pragma.cpp $(COMMON_SRC)
	$(CXX) $(KNLLB_FLAGS_pragma)  $(CPPFLAGS) $(CXXFLAGS) $(CXXFLAGS_pragma) $(LDFLAGS) $^ -o $@

BusSpeed%_scif: BusSpeed%_scif.cpp $(COMMON_SRC)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) $(CXXFLAGS_scif) $(LDFLAGS) $^ -o $@

BusSpeed_mic: main_mic.c
	$(CC) $(CPPFLAGS) $(CFLAGS_k1om) $(CFLAGS_scif) $(LDFLAGS_k1om) $^ -o $@

install-x86_64: $(TARGETS_x86_64)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/x86_64

install-k1om: $(TARGETS_k1om)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/k1om
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/k1om

install-x86_64-avx512: $(TARGETS_k1om)
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) $^ $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512

install-license:
	$(INSTALL) -d $(DESTDIR)$(docdir)
	$(INSTALL) -m 644 license_shoc.txt $(DESTDIR)$(docdir)

clean:
	-rm -rf $(TARGETS)

.PHONY: all knc knllb install install-knc install-knllb clean install-x86_64 install-k1om

=== stream/Makefile ===
#
#Copyright (2011) Intel Corporation All Rights Reserved.
#
#The source code, information and material ("Material") contained
#herein is owned by Intel Corporation or its suppliers or licensors,
#and title to such Material remains with Intel Corporation or its
#suppliers or licensors. The Material contains proprietary information
#of Intel or its suppliers and licensors. The Material is protected by
#worldwide copyright laws and treaty provisions. No part of the
#Material may be used, copied, reproduced, modified, published,
#uploaded, posted, transmitted, distributed or disclosed in any way
#without Intel's prior express written permission. No license under any
#patent, copyright or other intellectual property rights in the
#Material is granted to or conferred upon you, either expressly, by
#implication, inducement, estoppel or otherwise. Any license under such
#intellectual property rights must be express and approved by Intel in
#writing.
#
#Unless otherwise agreed by Intel in writing, you may not remove or alter
#this notice or any other notice embedded in Materials by Intel or Intel's
#suppliers or licensors in any way.
#

ICC ?= icc
MPIICC ?= mpiicc -cc=$(ICC)
TARGET_ICC ?= $(ICC)
INSTALL ?= install
VERSION ?= 0.0.0
prefix ?= /usr
exec_prefix ?= $(prefix)
libexecdir ?= $(exec_prefix)/libexec
datarootdir ?= $(prefix)/share
docdir ?= $(datarootdir)/doc/micperf
srcinstalldir ?= $(prefix)/src/micperf

EXTRA_CFLAGS = -O3 -qopenmp -DSTREAM_ARRAY_SIZE=64000000 \
-qopt-streaming-stores always -restrict -fstack-protector -D_FORTIFY_SOURCE=2

EXTRA_LDFLAGS = -qopenmp -Wl,-z,relro,-z,now

all: knc

knc: stream_mic

stream: stream.c stream_mpi.c
stream_mpi: stream_mpi.c

knlsb: stream stream_mpi
knllb: stream_mic

# Optimize KNL binaries to use AVX512 and KNC card binaries for the k1om architecture
knc: MIC_CFLAGS = -mmic
knlsb: CPU_CFLAGS = -xMIC-AVX512
knllb: MIC_CFLAGS = -xMIC-AVX512

install: install-knc

install-knc: install-k1om install-license

install-knlsb: install-license knlsb
	# on a system where the micperf rpm is installed, sources will cause $(INSTALL) to fail, error can be suppressed.
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) stream $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) stream_mpi $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512

install-knllb: install-x86_64-avx512 install-license

stream_mic: stream.c
	$(TARGET_ICC) $(MIC_CFLAGS) $(CPPFLAGS) $(CFLAGS) $(EXTRA_CFLAGS) $< \
		$(LDFLAGS) $(EXTRA_LDFLAGS) -o $@

stream:
	$(ICC) $(CPU_CFLAGS) $(CPPFLAGS) $(CFLAGS) $(EXTRA_CFLAGS) $< \
		$(LDFLAGS) $(EXTRA_LDFLAGS) -o $@
stream_mpi:
	$(MPIICC) $(CPU_CFLAGS) $(CPPFLAGS) $(CFLAGS) $(EXTRA_CFLAGS) $< \
                $(LDFLAGS) $(EXTRA_LDFLAGS) -o $@

install-k1om:
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/k1om
	$(INSTALL) stream_mic $(DESTDIR)$(libexecdir)/micperf/k1om

install-x86_64-avx512:
	$(INSTALL) -d $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512
	$(INSTALL) stream_mic $(DESTDIR)$(libexecdir)/micperf/x86_64_AVX512

install-license:
	$(INSTALL) -d $(DESTDIR)$(docdir)
	$(INSTALL) -m 644 license_stream.txt $(DESTDIR)$(docdir)

clean:
	-rm -rf stream_mic
	-rm -rf stream stream_mpi

.PHONY: all knc knlsb knllb install install-knc install-knlsb install-knllb clean install-k1om install-license

=== ut/Makefile ===
PYTEST ?= py.test
FILTER ?= ''
all: micp_ut

ifeq ($(PROJECT),knllb)
IGNORE_LIST =	micp_kernels_hplinpack_test.py micp_kernels_hpcg_test.py micp_kernels_generic_test.py micp_kernels_test_data.py
IGNORE = $(foreach file,$(IGNORE_LIST),--ignore="micp_ut/$(file)")
endif

micp_ut:
	export PYTHONPATH=$(pytest_installroot_sitepackages):$$PYTHONPATH; \
	export PYTHONPATH=../micp:$$PYTHONPATH; \
	$(PYTEST) -v -s -k $(FILTER) $(IGNORE) --color=no -v --cov-report html --cov-report annotate --cov ../micp ./micp_ut

clean:
	$(MAKE) -C micp_ut clean
	-rm -rf htmlcov
	-rm -rf tmp*
	-rm -rf micp_run_*

.PHONY: micp_ut clean

=== apps/sysdiag/Makefile ===
# Copyright 2012-2017 Intel Corporation.
# 
# This software is supplied under the terms of a license agreement or
# nondisclosure agreement with Intel Corporation and may not be copied
# or disclosed except in accordance with the terms of that agreement.

TOPDIR ?= ../..

-include $(TOPDIR)/common.mk

SYSDIAG_SRC_DIR = $(TOPDIR)/apps/sysdiag
SYSDIAG_SBIN_DIR ?= $(SBINDIR)
SYSDIAG_MODULE_DIR ?= $(DATAROOTDIR)/$(proj_target)/sysdiag
SYSDIAG_DOC_DIR = $(DOCDIR)/sysdiag

all :
	-

install : dirs
	sed -i -e "s|''#XPPSL_SYSDIAG_INSTALL_DIR#|\"$(abspath $(SYSDIAG_MODULE_DIR))\"|g" $(SYSDIAG_SRC_DIR)/sysdiag
	$(INSTALL_x) $(SYSDIAG_SRC_DIR)/sysdiag $(DESTDIR)/$(SYSDIAG_SBIN_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/__init__.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/sys_diag.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/sys_utils.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/diag_memory.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/diag_pcie.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/diag_power.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/diag_system.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(TOPDIR)/LICENSE_close.txt $(DESTDIR)/$(SYSDIAG_DOC_DIR)/LICENSE.txt

test:
	$(MAKE) -C ut sysdiag_ut

dirs :
	$(INSTALL_d) $(DESTDIR)/$(SYSDIAG_SBIN_DIR)
	$(INSTALL_d) $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_d) $(DESTDIR)/$(SYSDIAG_DOC_DIR)

clean :
	rm -rf *.pyc
	rm -rf __pycache__
	rm -rf ut/*pyc
	rm -rf ut/__pycache__

.PHONY : all install dirs clean test

=== deepbench/code/intel/convolution/libxsmm_conv/Makefile ===
# Export all variables to sub-make processes.
#.EXPORT_ALL_VARIABLES: #export

# Automatically disable parallel builds
# depending on the version of GNU Make.
# MAKE_PARALLEL=0: disable explicitly
# MAKE_PARALLEL=1: enable explicitly
ifeq (0,$(MAKE_PARALLEL))
.NOTPARALLEL:
else ifeq (,$(strip $(MAKE_PARALLEL)))
ifneq (3.82,$(firstword $(sort $(MAKE_VERSION) 3.82)))
.NOTPARALLEL:
endif
endif

ROOTDIR = $(abspath $(dir $(firstword $(MAKEFILE_LIST))))
SPLDIR = $(ROOTDIR)/samples
SCRDIR = $(ROOTDIR)/scripts
TSTDIR = $(ROOTDIR)/tests
SRCDIR = $(ROOTDIR)/src
INCDIR = include
BLDDIR = build
OUTDIR = lib
BINDIR = bin
DOCDIR = documentation

# subdirectories for prefix based installation
PINCDIR = $(INCDIR)
POUTDIR = $(OUTDIR)
PBINDIR = $(BINDIR)
PTSTDIR = tests
PDOCDIR = share/libxsmm

# initial default flags
CXXFLAGS = $(NULL)
CFLAGS = $(NULL)
DFLAGS = -DLIBXSMM_BUILD
IFLAGS = -I$(INCDIR) -I$(BLDDIR) -I$(SRCDIR)

# Python interpreter
PYTHON ?= python

# Version numbers according to interface (version.txt)
VERSION_MAJOR ?= $(shell $(PYTHON) $(SCRDIR)/libxsmm_utilities.py 1)
VERSION_MINOR ?= $(shell $(PYTHON) $(SCRDIR)/libxsmm_utilities.py 2)

# THRESHOLD problem size (M x N x K) determining when to use BLAS
# A value of zero (0) populates a default threshold
THRESHOLD ?= 0

# Generates M,N,K-combinations for each comma separated group e.g., "1, 2, 3" gnerates (1,1,1), (2,2,2),
# and (3,3,3). This way a heterogeneous set can be generated e.g., "1 2, 3" generates (1,1,1), (1,1,2),
# (1,2,1), (1,2,2), (2,1,1), (2,1,2) (2,2,1) out of the first group, and a (3,3,3) for the second group
# To generate a series of square matrices one can specify e.g., make MNK=$(echo $(seq -s, 1 5))
# Alternative to MNK, index sets can be specified separately according to a loop nest relationship
# (M(N(K))) using M, N, and K separately. Please consult the documentation for further details.
MNK ?= 0

# Enable thread-local cache of recently dispatched kernels either
# 0: "disable", 1: "enable", or small power-of-two number.
CACHE ?= 1

# Issue software prefetch instructions (see end of section
# https://github.com/hfp/libxsmm/#generator-driver)
# Use the enumerator 1...10, or the exact strategy
# name pfsigonly...AL2_BL2viaC_CL2.
#  1: auto-select
#  2: pfsigonly
#  3: BL2viaC
#  4: curAL2
#  7: curAL2_BL2viaC
#  5: AL2
#  6: AL2_BL2viaC
#  8: AL2jpst
#  9: AL2jpst_BL2viaC
# 10: AL2_BL2viaC_CL2
PREFETCH ?= 1

# Preferred precision when registering statically generated code versions
# 0: SP and DP code versions to be registered
# 1: SP only
# 2: DP only
PRECISION ?= 0

# Support SMM kernels with larger extent(s)
# 0: optimized JIT descriptor size
# 1: regular descriptor size
BIG ?= 1

# Specify an alignment (Bytes)
ALIGNMENT ?= 64

# Generate code using aligned Load/Store instructions
# !=0: enable if lda/ldc (m) is a multiple of ALIGNMENT
# ==0: disable emitting aligned Load/Store instructions
ALIGNED_STORES ?= 0
ALIGNED_LOADS ?= 0

# Alpha argument of GEMM
# Supported: 1.0
ALPHA ?= 1
ifneq (1,$(ALPHA))
  $(error ALPHA needs to be 1)
endif

# Beta argument of GEMM
# Supported: 0.0, 1.0
# 0: C  = A * B
# 1: C += A * B
BETA ?= 1
ifneq (1,$(BETA))
ifneq (0,$(BETA))
  $(error BETA needs to be either 0 or 1)
endif
endif

# Determines if the library is thread-safe
THREADS ?= 1

# 0: produces shared library files suitable for dynamic linkage
# 1: produces library archives suitable for static linkage
STATIC ?= 1

# Determines if the library can act as a wrapper-library (GEMM)
# 1: enables wrapping SGEMM and DGEMM
# 2: enables wrapping DGEMM only
WRAP ?= 0

# JIT backend is enabled by default
JIT ?= 1

# TRACE facility
INSTRUMENT ?= $(TRACE)

# target library for a broad range of systems
ifneq (0,$(JIT))
  SSE ?= 1
endif

# Profiling JIT code using Linux Perf
# PERF=0: disabled (default)
# PERF=1: enabled (without JITDUMP)
# PERF=2: enabled (with JITDUMP)
#
# Additional support for jitdump
# JITDUMP=0: disabled (default)
# JITDUMP=1: enabled
# PERF=2: enabled
#
ifneq (,$(PERF))
ifneq (0,$(PERF))
ifneq (1,$(PERF))
  JITDUMP ?= 1
endif
endif
endif
JITDUMP ?= 0

ifneq (0,$(JITDUMP))
  PERF ?= 1
endif

PERF ?= 0
ifneq (0,$(PERF))
  SYM ?= 1
endif

# OpenMP is disabled by default and LIBXSMM is
# always agnostic wrt the threading runtime
OMP ?= 0

ifneq (,$(MKL))
  BLAS = $(MKL)
endif

BLAS_WARNING ?= 0
ifeq (0,$(STATIC))
  ifeq (Windows_NT,$(OS)) # !UNAME
    BLAS_WARNING = 1
    BLAS ?= 2
  else ifeq (Darwin,$(shell uname))
    BLAS_WARNING = 1
    BLAS ?= 2
  endif
endif

ifneq (1,$(CACHE))
  DFLAGS += -DLIBXSMM_CAPACITY_CACHE=$(CACHE)
endif

# disable lazy initialization and rely on ctor attribute
ifeq (0,$(INIT))
  DFLAGS += -DLIBXSMM_CTOR
endif

# state to be excluded from tracking the (re-)build state
EXCLUDE_STATE = BLAS_WARNING PREFIX

# include common Makefile artifacts
include $(ROOTDIR)/Makefile.inc

# target library for a broad range of systems
ifneq (0,$(JIT))
ifeq (file,$(origin AVX))
  AVX_STATIC = 0
endif
endif
AVX_STATIC ?= $(AVX)

ifeq (1,$(AVX_STATIC))
  GENTARGET = snb
else ifeq (2,$(AVX_STATIC))
  GENTARGET = hsw
else ifeq (3,$(AVX_STATIC))
  GENTARGET = knl
else ifneq (0,$(SSE))
  GENTARGET = wsm
else
  GENTARGET = noarch
endif

ifeq (0,$(STATIC))
  GENERATOR = @$(ENV) \
    LD_LIBRARY_PATH=$(OUTDIR):$${LD_LIBRARY_PATH} \
    PATH=$(OUTDIR):$${PATH} \
  $(BINDIR)/libxsmm_gemm_generator
else
  GENERATOR = $(BINDIR)/libxsmm_gemm_generator
endif

INDICES ?= $(shell $(PYTHON) $(SCRDIR)/libxsmm_utilities.py -1 $(THRESHOLD) $(words $(MNK)) $(MNK) $(words $(M)) $(words $(N)) $(M) $(N) $(K))
NINDICES = $(words $(INDICES))

HEADERS = $(wildcard $(SRCDIR)/template/*.c) $(wildcard $(SRCDIR)/*.h) \
          $(SRCDIR)/libxsmm_hash.c $(SRCDIR)/libxsmm_gemm_diff.c \
          $(ROOTDIR)/include/libxsmm_cpuid.h \
          $(ROOTDIR)/include/libxsmm_dnn.h \
          $(ROOTDIR)/include/libxsmm_frontend.h \
          $(ROOTDIR)/include/libxsmm_fsspmdm.h \
          $(ROOTDIR)/include/libxsmm_generator.h \
          $(ROOTDIR)/include/libxsmm_intrinsics_x86.h \
          $(ROOTDIR)/include/libxsmm_macros.h \
          $(ROOTDIR)/include/libxsmm_malloc.h \
          $(ROOTDIR)/include/libxsmm_spmdm.h \
          $(ROOTDIR)/include/libxsmm_sync.h \
          $(ROOTDIR)/include/libxsmm_timer.h \
          $(ROOTDIR)/include/libxsmm_typedefs.h
SRCFILES_LIB = $(patsubst %,$(SRCDIR)/%, \
          libxsmm_main.c libxsmm_cpuid_x86.c libxsmm_malloc.c \
          libxsmm_sync.c libxsmm_dump.c libxsmm_timer.c libxsmm_perf.c \
          libxsmm_gemm.c libxsmm_trans.c libxsmm_spmdm.c libxsmm_fsspmdm.c \
          libxsmm_dnn.c libxsmm_dnn_handle.c \
          libxsmm_dnn_convolution_forward.c \
          libxsmm_dnn_convolution_backward.c \
          libxsmm_dnn_convolution_weight_update.c \
          libxsmm_dnn_convolution_winograd_forward.c \
          libxsmm_dnn_convolution_winograd_backward.c \
          libxsmm_dnn_convolution_winograd_weight_update.o )

SRCFILES_KERNELS = $(patsubst %,$(BLDDIR)/mm_%.c,$(INDICES))
SRCFILES_GEN_LIB = $(patsubst %,$(SRCDIR)/%,$(wildcard $(SRCDIR)/generator_*.c) libxsmm_trace.c)
SRCFILES_GEN_GEMM_BIN = $(patsubst %,$(SRCDIR)/%,libxsmm_generator_gemm_driver.c)
SRCFILES_GEN_CONVWINO_BIN = $(patsubst %,$(SRCDIR)/%,libxsmm_generator_convolution_winograd_driver.c)
SRCFILES_GEN_CONV_BIN = $(patsubst %,$(SRCDIR)/%,libxsmm_generator_convolution_driver.c)
OBJFILES_GEN_LIB = $(patsubst %,$(BLDDIR)/intel64/%.o,$(basename $(notdir $(SRCFILES_GEN_LIB))))
OBJFILES_GEN_GEMM_BIN = $(patsubst %,$(BLDDIR)/intel64/%.o,$(basename $(notdir $(SRCFILES_GEN_GEMM_BIN))))
OBJFILES_GEN_CONVWINO_BIN = $(patsubst %,$(BLDDIR)/intel64/%.o,$(basename $(notdir $(SRCFILES_GEN_CONVWINO_BIN))))
OBJFILES_GEN_CONV_BIN = $(patsubst %,$(BLDDIR)/intel64/%.o,$(basename $(notdir $(SRCFILES_GEN_CONV_BIN))))
OBJFILES_GEN_LIB = $(patsubst %,$(BLDDIR)/intel64/%.o,$(basename $(notdir $(SRCFILES_GEN_LIB))))
OBJFILES_HST = $(patsubst %,$(BLDDIR)/intel64/%.o,$(basename $(notdir $(SRCFILES_LIB))))
OBJFILES_MIC = $(patsubst %,$(BLDDIR)/mic/%.o,$(basename $(notdir $(SRCFILES_LIB))))
KRNOBJS_HST  = $(patsubst %,$(BLDDIR)/intel64/mm_%.o,$(INDICES))
KRNOBJS_MIC  = $(patsubst %,$(BLDDIR)/mic/mm_%.o,$(INDICES))
EXTOBJS_HST  = $(BLDDIR)/intel64/libxsmm_ext.o \
               $(BLDDIR)/intel64/libxsmm_ext_gemm.o $(BLDDIR)/intel64/libxsmm_ext_trans.o
EXTOBJS_MIC  = $(BLDDIR)/mic/libxsmm_ext.o \
               $(BLDDIR)/mic/libxsmm_ext_gemm.o $(BLDDIR)/mic/libxsmm_ext_trans.o
NOBLAS_HST   = $(BLDDIR)/intel64/libxsmm_noblas.o
NOBLAS_MIC   = $(BLDDIR)/mic/libxsmm_noblas.o

# list of object might be "incomplete" if not all code gen. FLAGS are supplied with clean target!
OBJECTS = $(OBJFILES_GEN_LIB) $(OBJFILES_GEN_GEMM_BIN) $(OBJFILES_GEN_CONV_BIN) $(OBJFILES_GEN_CONVWINO_BIN) $(OBJFILES_HST) $(OBJFILES_MIC) \
          $(KRNOBJS_HST) $(KRNOBJS_MIC) $(EXTOBJS_HST) $(EXTOBJS_MIC) $(NOBLAS_HST) $(NOBLAS_MIC)
ifneq (,$(strip $(FC)))
  FTNOBJS = $(BLDDIR)/intel64/libxsmm-mod.o $(BLDDIR)/mic/libxsmm-mod.o
endif

ifneq (,$(strip $(TEST)))
.PHONY: run-tests
run-tests: tests
endif

.PHONY: libxsmm
ifeq (0,$(COMPATIBLE))
libxsmm: lib generator
else
libxsmm: lib
endif

.PHONY: lib
lib: headers drytest lib_hst lib_mic

.PHONY: all
all: libxsmm samples

.PHONY: headers
headers: cheader cheader_only fheader

.PHONY: header-only
header-only: cheader_only

.PHONY: header_only
header_only: header-only

.PHONY: interface
interface: headers module

.PHONY: lib_mic
lib_mic: clib_mic flib_mic ext_mic noblas_mic

.PHONY: lib_hst
lib_hst: clib_hst flib_hst ext_hst noblas_hst

PREFETCH_UID = 0
PREFETCH_SCHEME = nopf
PREFETCH_TYPE = 0

ifneq (0,$(shell echo $$((2 <= $(PREFETCH) && $(PREFETCH) <= 10))))
  PREFETCH_UID = $(PREFETCH)
else ifeq (1,$(PREFETCH)) # auto
  PREFETCH_UID = 1
else ifeq (pfsigonly,$(PREFETCH))
  PREFETCH_UID = 2
else ifeq (BL2viaC,$(PREFETCH))
  PREFETCH_UID = 3
else ifeq (curAL2,$(PREFETCH))
  PREFETCH_UID = 4
else ifeq (curAL2_BL2viaC,$(PREFETCH))
  PREFETCH_UID = 5
else ifeq (AL2,$(PREFETCH))
  PREFETCH_UID = 6
else ifeq (AL2_BL2viaC,$(PREFETCH))
  PREFETCH_UID = 7
else ifeq (AL2jpst,$(PREFETCH))
  PREFETCH_UID = 8
else ifeq (AL2jpst_BL2viaC,$(PREFETCH))
  PREFETCH_UID = 9
else ifeq (AL2_BL2viaC_CL2,$(PREFETCH))
  PREFETCH_UID = 10
endif

# Mapping build options to libxsmm_gemm_prefetch_type (see include/libxsmm_typedefs.h)
ifeq (1,$(PREFETCH_UID))
  # Prefetch "auto" is a pseudo-strategy introduced by the frontend;
  # select "nopf" for statically generated code.
  PREFETCH_SCHEME = nopf
  PREFETCH_TYPE = -1
else ifeq (2,$(PREFETCH_UID))
  PREFETCH_SCHEME = pfsigonly
  PREFETCH_TYPE = 1
else ifeq (3,$(PREFETCH_UID))
  PREFETCH_SCHEME = BL2viaC
  PREFETCH_TYPE = 8
else ifeq (4,$(PREFETCH_UID))
  PREFETCH_SCHEME = curAL2
  PREFETCH_TYPE = 16
else ifeq (5,$(PREFETCH_UID))
  PREFETCH_SCHEME = curAL2_BL2viaC
  PREFETCH_TYPE = $(shell echo $$((8 | 16)))
else ifeq (6,$(PREFETCH_UID))
  PREFETCH_SCHEME = AL2
  PREFETCH_TYPE = 2
else ifeq (7,$(PREFETCH_UID))
  PREFETCH_SCHEME = AL2_BL2viaC
  PREFETCH_TYPE = $(shell echo $$((8 | 2)))
else ifeq (8,$(PREFETCH_UID))
  PREFETCH_SCHEME = AL2jpst
  PREFETCH_TYPE = 4
else ifeq (9,$(PREFETCH_UID))
  PREFETCH_SCHEME = AL2jpst_BL2viaC
  PREFETCH_TYPE = $(shell echo $$((8 | 4)))
else ifeq (10,$(PREFETCH_UID))
  PREFETCH_SCHEME = AL2_BL2viaC_CL2
  PREFETCH_TYPE = $(shell echo $$((8 | 2 | 32)))
endif
ifeq (,$(PREFETCH_SCHEME_MIC))
  PREFETCH_SCHEME_MIC = $(PREFETCH_SCHEME)
endif

# Mapping build options to libxsmm_gemm_flags (see include/libxsmm_typedefs.h)
FLAGS = $(shell echo $$((((0!=$(ALIGNED_LOADS))*4) | ((0!=$(ALIGNED_STORES))*8))))

SUPPRESS_UNUSED_VARIABLE_WARNINGS = LIBXSMM_UNUSED(A); LIBXSMM_UNUSED(B); LIBXSMM_UNUSED(C);
ifneq (nopf,$(PREFETCH_SCHEME))
  #SUPPRESS_UNUSED_VARIABLE_WARNINGS += LIBXSMM_UNUSED(A_prefetch); LIBXSMM_UNUSED(B_prefetch);
  #SUPPRESS_UNUSED_PREFETCH_WARNINGS = $(NULL)  LIBXSMM_UNUSED(C_prefetch);~

=== deepbench/code/intel/convolution/mkl_conv/Makefile ===
#******************************************************************************
# Copyright 2017 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#*******************************************************************************

CONVLIB ?= MKL

ifeq ($(CONVLIB),MKL)
ifeq ($(MKLROOT),)
    $(error MKLROOT is empty. Please install Intel MKL 2017 or newer, or \
        download an Intel MKLML package from \
        https://github.com/intel/caffe/releases.)
endif
PREP_MKL = $(shell sh ../../externals/prepare_mkl.sh)
MKLROOT  = $(word 1, $(PREP_MKL))
MKLLIB   = $(word 2, $(PREP_MKL))
EXTRACXXFLAGS = -I$(MKLROOT)/include -DUSE_MKL
ifeq ($(MKLLIB), mklml_intel)
    EXTRALIB = -L$(MKLROOT)/lib -lmklml_intel
endif
ifeq ($(MKLLIB), mkl_rt)
    EXTRALIB =  -Wl,--start-group ${MKLROOT}/lib/intel64/libmkl_intel_lp64.a ${MKLROOT}/lib/intel64/libmkl_intel_thread.a ${MKLROOT}/lib/intel64/libmkl_core.a -Wl,--end-group
endif
EXTRALIB += -liomp5 -lpthread -lm -ldl
endif

ifeq ($(CONVLIB),MKLDNN)
ifeq ($(MKLDNNROOT),)
    $(error MKLDNNROOT is empty. Please build MKLDNN from \
        https://github.com/01org/mkl-dnn and point MKLDNNROOT \
        to the install directory.)
endif
EXTRACXXFLAGS = -I$(MKLDNNROOT)/include -DUSE_MKLDNN
EXTRALIB = -L$(MKLDNNROOT)/lib -lmkldnn
endif

INPUT_H ?= input.h

ifeq ($(DEBUG), 1)
OPTFLAGS = -O0 -g
else
OPTFLAGS = -O3
endif

CXX      = icpc
CXXFLAGS = -Wall -std=c++11 $(OPTFLAGS) $(EXTRACXXFLAGS) -DINPUT_H=\"$(INPUT_H)\" -D_FORTIFY_SOURCE=2 -fstack-protector -Wl,-z,relro,-z,now
OBJS     = std_conv_bench.o

all : std_conv_bench

std_conv_bench : std_conv_bench.o
	$(CXX) $(CXXFLAGS) $^  $(EXTRALIB)  -o $@

std_conv_bench.o : std_conv_bench.cpp input.h
	$(CXX) $(CXXFLAGS) -c -o $@ $<

clean :
	rm -f *.o std_conv_bench.o std_conv_bench

=== deepbench/code/intel/convolution/libxsmm_conv/samples/barrier/Makefile ===
# Export all variables to sub-make processes.
#.EXPORT_ALL_VARIABLES: #export

# Automatically disable parallel builds
# depending on the version of GNU Make.
# MAKE_PARALLEL=0: disable explicitly
# MAKE_PARALLEL=1: enable explicitly
ifeq (0,$(MAKE_PARALLEL))
.NOTPARALLEL:
else ifeq (,$(MAKE_PARALLEL))
ifneq (3.82,$(firstword $(sort $(MAKE_VERSION) 3.82)))
.NOTPARALLEL:
endif
endif

ROOTDIR = $(abspath $(dir $(firstword $(MAKEFILE_LIST))))
DEPDIR = ../..
SRCDIR = $(ROOTDIR)
INCDIR = .
BLDDIR = build
OUTDIR = .

CXXFLAGS = $(NULL)
CFLAGS = $(NULL)
DFLAGS = $(NULL)
IFLAGS = -I$(INCDIR) -I$(DEPDIR)/include

BLAS = 0
SYM = 1
OMP = 1

# include common Makefile artifacts
include $(DEPDIR)/Makefile.inc

OUTNAME := $(shell basename $(ROOTDIR))
HEADERS := $(wildcard $(INCDIR)/*.h) $(wildcard $(INCDIR)/*.hpp) $(wildcard $(INCDIR)/*.hxx) $(wildcard $(INCDIR)/*.hh) \
           $(wildcard $(SRCDIR)/*.h) $(wildcard $(SRCDIR)/*.hpp) $(wildcard $(SRCDIR)/*.hxx) $(wildcard $(SRCDIR)/*.hh)
CPPSRCS := $(wildcard $(SRCDIR)/*.cpp)
CXXSRCS := $(wildcard $(SRCDIR)/*.cxx)
CCXSRCS := $(wildcard $(SRCDIR)/*.cx)
CSOURCS := $(wildcard $(SRCDIR)/*.c)
FXXSRCS := $(wildcard $(SRCDIR)/*.f)
F77SRCS := $(wildcard $(SRCDIR)/*.F)
F90SRCS := $(wildcard $(SRCDIR)/*.f90) $(wildcard $(SRCDIR)/*.F90)
CPPOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CPPSRCS:.cpp=-cpp.o)))
CXXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CXXSRCS:.cxx=-cxx.o)))
CCXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CCXSRCS:.cc=-cc.o)))
COBJCTS := $(patsubst %,$(BLDDIR)/%,$(notdir $(CSOURCS:.c=-c.o)))
FXXOBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(FXXSRCS:.f=-f.o)))
F77OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F77SRCS:.F=-f77.o)))
F90OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F90SRCS:.f90=-f90.o)))
F90OBJS := $(patsubst %,$(BLDDIR)/%,$(notdir $(F90OBJS:.F90=-f90.o)))
SOURCES := $(CPPSRCS) $(CXXSRCS) $(CCXSRCS) $(CSOURCS)
OBJECTS := $(CPPOBJS) $(CXXOBJS) $(CCXOBJS) $(COBJCTS)
FTNSRCS := $(FXXSRCS) $(F77SRCS) $(F90SRCS)
MODULES := $(addsuffix .mod,$(basename $(FTNSRCS))) $(addsuffix .modmic,$(basename $(FTNSRCS)))
FTNOBJS := $(FXXOBJS) $(F77OBJS) $(F90OBJS)
XFILES := $(OUTDIR)/$(OUTNAME)

.PHONY: all
all: $(XFILES)

.PHONY: compile
compile: $(OBJECTS) $(FTNOBJS)

$(OUTDIR)/$(OUTNAME): $(OUTDIR)/.make $(OBJECTS) $(LIBNAME).$(LIBEXT) $(LIBNAME)ext.$(LIBEXT)
	$(LD) -o $@ $(OBJECTS) \
		$(call abslib,$(LIBNAME).$(LIBEXT)) \
		$(call abslib,$(LIBNAME)noblas.$(LIBEXT)) \
		$(BLASLIB) $(SLDFLAGS) $(LDFLAGS) $(CLDFLAGS)

$(BLDDIR)/%-cpp.o: $(SRCDIR)/%.cpp .state $(BLDDIR)/.make $(HEADERS) $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(CXX) $(CXXFLAGS) $(DFLAGS) $(IFLAGS) $(CTARGET) -c $< -o $@

$(BLDDIR)/%-c.o: $(SRCDIR)/%.c .state $(BLDDIR)/.make $(HEADERS) $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(CC) $(CFLAGS) $(DFLAGS) $(IFLAGS) $(CTARGET) -c $< -o $@

$(BLDDIR)/%-f.o: $(SRCDIR)/%.f .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f90.o: $(SRCDIR)/%.f90 .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f90.o: $(SRCDIR)/%.F90 .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

$(BLDDIR)/%-f77.o: $(SRCDIR)/%.F .state $(BLDDIR)/.make $(ROOTDIR)/Makefile $(DEPDIR)/Makefile.inc
	$(FC) $(FCMTFLAGS) $(FCFLAGS) $(DFLAGS) $(IFLAGS) $(FTARGET) -c $< -o $@

.PHONY: clean
clean:
ifneq ($(abspath $(BLDDIR)),$(ROOTDIR))
ifneq ($(abspath $(BLDDIR)),$(abspath .))
	@rm -rf $(BLDDIR)
endif
endif
ifneq (,$(wildcard $(BLDDIR))) # still exists
	@rm -f $(OBJECTS) $(OBJECTX) $(FTNOBJS) $(FTNOBJX) *__genmod.* fit.log *.dat *.mhd
	@rm -f $(BLDDIR)/*.gcno $(BLDDIR)/*.gcda $(BLDDIR)/*.gcov
endif
	@rm -f .make .state

.PHONY: realclean
realclean: clean
ifneq ($(abspath $(OUTDIR)),$(ROOTDIR))
ifneq ($(abspath $(OUTDIR)),$(abspath .))
	@rm -rf $(OUTDIR)
endif
endif
ifneq (,$(wildcard $(OUTDIR))) # still exists
	@rm -f $(OUTDIR)/libxsmm.$(DLIBEXT) $(OUTDIR)/*.stackdump
	@rm -f $(XFILES) $(MODULES)
endif

=== changelog ===
zonesort (1.0+xpps-2.2.0.573) artful-xpps; urgency=low

  * The zonesort module CI build.

 -- Intel Corporation <https://supporttickets.intel.com>  Thu, 09 Nov 2017 14:51:07 +0000

zonesort (1.0+xpps-1) unstable; urgency=low

  * Inititial zonesort release for Intel(R) Xeon Phi(TM) processor software.

 -- Adam Lessnau <adam.lessnau@intel.com>  Mon, 30 Oct 2017 12:31:55 +0100

=== debian/changelog ===
memkind (1.6.0+xpps-2.2.0.573) artful-xpps; urgency=low

  * The memkind source code used by the XPPS release.
  * See ChangeLog for more details.

 -- Intel Corporation <https://supporttickets.intel.com>  Thu, 09 Nov 2017 14:51:06 +0000

=== control ===
Source: zonesort
Origin: Intel(R) Xeon Phi(TM) processor software
Maintainer: Intel Corporation <https://supporttickets.intel.com>
Section: admin
Priority: optional
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 9)

Package: zonesort
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Zone free list sorter
 The zonesort module provides mechanism to change order in a list of free pages kept
 in Linux kernel buddy allocator. The order is changed so to minimize possible
 page collisions later when those pages are served to the application.
 The algorithm assumes that the system has up to 16GB of direct-mapped cache.

=== debian/control ===
Source: memkind
Origin: Intel(R) Xeon Phi(TM) processor software
Maintainer: Intel Corporation <https://supporttickets.intel.com>
Section: utils
Priority: optional
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 9)
Homepage: https://github.com/memkind/memkind

Package: memkind
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:
 The memkind library is an user extensible heap manager built on top of
 jemalloc which enables control of memory characteristics and a
 partitioning of the heap between kinds of memory. The kinds of memory
 are defined by operating system memory policies that have been applied
 to virtual address ranges. Memory characteristics supported by
 memkind without user extension include control of NUMA and page size
 features. The jemalloc non-standard interface has been extended to
 enable specialized arenas to make requests for virtual memory from the
 operating system through the memkind partition interface. Through the
 other memkind interfaces the user can control and extend memory
 partition features and allocate memory while selecting enabled
 features. This software is being made available for early evaluation.
 Feedback on design or implementation is greatly appreciated.


Package: memkind-tests
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:
 Tests for memkind package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export PYBUILD_SYSTEM=custom
export PYBUILD_DISABLE=clean configure
export PYBUILD_BUILD_ARGS=make knlsb VERSION=2.2.0+xpps-2.2.0.573
export PYBUILD_INSTALL_ARGS=make install-knlsb VERSION=2.2.0+xpps-2.2.0.573 DESTDIR={destdir}

PACKAGE_NAME = micperf

%:
	dh $@ --with python2 --buildsystem=pybuild

# Ignore external icc dependencies
override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

=== rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export MODULE_VERSION = $(shell dpkg-parsechangelog -SVersion)
export KERNEL_SRC = /usr/src/linux-headers-4.13.0-16-generic

%:
	dh $@
